typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned char uchar;

#include <dos.h>

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

/*
uchar testkey(uchar ligne,uchar colonne)
{			// teste une touche particulire et renvoie 0 si cette touche n'est pas presse
			// touches multiples acceptes
asm	{
	mov ax,1
	mov cl,ligne
	shl ax,cl		// ax = 2^ligne
	out 0x13,ax
	mov cx,10 
} key_loop: asm {
    loop key_loop
	in al,0x13		// la valeur du port a change si une touche est pressee
	mov ah,1
	mov cl,colonne
	shl ah,cl		// ah = 2^colonne
	and al,ah		// on ne garde que la valeur du bit a observer
	}
	return _AL;
}
*/
///////////////////////////////////////////////////////////////////////////////////////

void contplus()
{
asm { 
	xor bl,bl		// 0 pour assombrir
	mov ah,22h		// service 22h de l'interruption 7Ch
	int 7Ch
	}
}

///////////////////////////////////////////////////////////////////////////////////////

void contmoins()
{
asm { 
	mov bl,1		// 1 pour eclaircir
	mov ah,22h		// service 22h de l'interruption 7Ch
	int 7Ch
	}
}

///////////////////////////////////////////////////////////////////////////////////////////

static void interrupt (*ptr_int09)(__CPPARGS);
static void interrupt (*ptr_int4A)(__CPPARGS);

void interrupt intnulle() {}
void inter(uchar active)
{
	if (active==0)
	{
		ptr_int09 = _dos_getvect(0x09);
		ptr_int4A = _dos_getvect(0x4A);
	}

	_dos_setvect(0x9,active ? ptr_int09 : intnulle);
	_dos_setvect(0x4A,active ? ptr_int4A : intnulle);
}

