
void OutChar(int x,int y,char c,unsigned char col,unsigned char *font)
{

  char ch=0;
  int i,xy;
  uchar l,l1,l2;
  static uchar point1,point2,point3,point4,point5,point6;
  if (c>=32 && c<=122) 
    ch=c-32;
  else ch='?'-32;
  
  xy=1023-(x/8+y*16);
  for(i=0;i<font[1];i++)
  {
    l=font[font[1]*ch+i+2];

    point1=peekb(0x1A60,xy);
    point2=peekb(0x1A60,xy-1);
	point3=peekb(0x1AE0,xy);
    point4=peekb(0x1AE0,xy-1);
	point5=peekb(0x1B60,xy);
    point6=peekb(0x1B60,xy-1);
    l1=l >> x%8;
    l2=l << (8-x%8);
    switch (col)
    {
      case 0:
        point1&=~l1; 
        point2&=~l2; 
        point3&=~l1; 
        point4&=~l2; 
		point5&=~l1; 
        point6&=~l2; 
      break;      
      case 1:
        point1|=l1; 
        point2|=l2; 
		point3&=~l1; 
        point4&=~l2; 
        point5|=l1; 
        point6|=l2; 
      break;
	  case 2:
	    point1&=~l1; 
        point2&=~l2; 
        point3|=l1; 
        point4|=l2; 
		point5|=l1; 
        point6|=l2;         
      break;
	  case 3:
		point1|=l1; 
        point2|=l2; 
		point3|=l1; 
        point4|=l2; 
		point5|=l1; 
        point6|=l2; 
	 break;
    }
    pokeb(0x1A60,xy,point1);
    pokeb(0x1A60,xy-1,point2);
    pokeb(0x1AE0,xy,point3);
    pokeb(0x1AE0,xy-1,point4);
	pokeb(0x1B60,xy,point5);
    pokeb(0x1B60,xy-1,point6);
    xy-=16;
    /*
    for(j=7;j>8-font[0]-1;j--) 
    {
      if (l/bin[j]==1) put_pix(x+7-j,y+i,col);
      l=l%bin[j];
    }*/
  } 
}

void OutChar2(int x,int y,char c,char col1,char col2,unsigned char *font)
{

  OutChar(x,y,'#',col2,font);
  OutChar(x,y,c,col1,font);
}

void OutStr(int x,int y,char str[],unsigned char col,unsigned char *font)
{
  int i;
  for(i=0;str[i]!='\0';i++)
  OutChar(x+(font[0]+1)*i,y,str[i],col,font);
}

void OutStrTI(int x,int y,char str[],unsigned char col,unsigned char *font)
{
  int i;
  int dx=0;
  if (x<0) return;
  if (col==4) col=0;
  for(i=0;str[i]!='\0';i++)
  {
     OutChar(VXS+x+dx,y,str[i],col,font);
	 if (str[i]=='m' || str[i]=='w')
		 dx+=6;
	 else
		 dx+=4;
  }
}

void OutStr2(int x,int y,char str[],unsigned char col,char col2,unsigned char *font)
{
  int i;
  for(i=0;str[i]!='\0';i++)
  OutChar2(x+(font[0]+1)*i,y,str[i],col,col2,font);
}
/*
void OutStr2(int x,int y,char str[],unsigned char col, char col2,char *font)
{
  int i;
  vLine(x-1,y,y+font[1]-1,col2);
  for(i=0;str[i]!='\0';i++)
  {
    OutChar2(x+(font[0]+1)*i,y,str[i],col,col2,font);
    vLine(x+(font[0]+1)*(i+1)-1,y,y+font[1]-1,col2);
  }
  hLine(x-1,y-1,x+i*(font[0]+1)-1,col2);
  hLine(x-1,y+font[1],x+i*(font[0]+1)-1,col2);
}
	
void OutStrDown(int x,int y,char st[],unsigned char col,char *font)
	{int i;
     char c;
	  for(i=0;st[i]!='\0';i++){
	    if (st[i]>=65 && st[i]<=90) c=st[i]+32; else c=st[i];
        OutChar(x+5*i,y-2,c,col,font);
      }
    }
/*
void drawStr2(int x,int y,char st[]){
    drawStr(x+1,y+1,st,1);
    drawStr(x,y,st,2);
}*/
void OutNumZ(int x,int y,long number,int length,unsigned int col,unsigned char *font)
{
  int i;
  long l=number;
  for (i=length-1;i>=0;i--)
  {
    OutChar(x+i*(font[0]+1),y,'0'+l%10,col,font);
    l=l/10;
  }

}

void OutNumZ2(int x,int y,long number,int length,unsigned int col,unsigned int col2,unsigned char *font)
{
  int i;
  long l=number;
  for (i=length-1;i>=0;i--)
  {
    OutChar2(x+i*(font[0]+1),y,'0'+l%10,col,col2,font);
    l=l/10;
  }

}

void OutNum(int x,int y,long n,int l,unsigned int col,unsigned char *font)
	{int i,d=0;
	long r=n;
	char st[10];/*a voir*/
	if(r<0) r=-r;
	for(i=l-1;i>=0;i--)
		{if (r==0 && i!=l-1)
			{d++;
			st[i]=' ';}
		else st[i]=48+r%10;
		r/=10;}
	if(n<0) st[d-1]='-';
	st[l]='\0';
	OutStr(x,y,st,col,font);}

/*affichage d'un nombre de 4 chiffre infrieur ou gal  1000*/
/*
void drawNum2(int x,int y,int n,unsigned int seg)
	{int i;
	if (n==1000)
		{for(i=y;i<y+5;i++) put_pix(x,i,2);
		drawStr(x+2,y,"000",seg);}
	else {int r=n;
		char st[4];
		for(i=y;i<y+5;i++) put_pix(x,i,0);
		for(i=2;i>=0;i--)
			{st[i]=(r==0 && i!=2?' ':48+r%10);
			r/=10;}
		st[3]='\0';
		drawStr(x+2,y,st,seg);}
	}
	
*/	/*
long OutGetVal(int x,int y,int max,char col,char *font){
     int i,k=0;
	 long val=0;
	 emptybuf();
	 actint9();
	 for(i=0;i<max && k!=EXE;i++){
	   while((k<48||k>57)&&(k!=EXE||i==0)) k=getch();
	   if (k!=EXE){
	     OutChar(x+5*i,y,k,col, font);
		 val=val*10+k-48;k=0;
	   }
	 }
    desactint9();
	return val;
}
*/
/*
void OutGetStr(char *out_str,int x,int y,int leng,char col, char bkcol,char *font){
    int i,k=1,c=0;
	out_str[0]=0;
	fill_rect(x,y-1,x+leng*(font[0]+1)+3,y+5,bkcol);
	OutChar(x,y-1,'#',col,font);
	for(i=0;k!=G_EXE;i++){
	
        k=tgetkey();
	    if (k!=G_EXE){c=k;
		  if (k==G_DEL)
		  {
		    if (i>0)
		    {
		      i--;
		      OutChar(x+(font[0]+1)*i+5,y-1,'#',bkcol,font);
		      OutChar(x+(font[0]+1)*i,y-1,'#',col,font);
		      out_str[i]=0;
   		    }
   		    i--;
		  }
		  else
          if (i<leng)
		  {
		    if (c>=97 && c<=122){
		      c-=32;
              OutChar(x+(font[0]+1)*i,y-1,'#',bkcol,font);
		      OutChar(x+(font[0]+1)*i,y-1,c,col,font);
		      OutChar(x+(font[0]+1)*i+(font[0]+1),y-1,'#',col,font);
		      out_str[i]=c;
		      out_str[i+1]=0;
		      wait(30);
		    } else i--;
		  } else i=leng-1;
		  k=0;
		}
   }
   
}

void OutDrawMenu(char *menu,  char *font)
{ 
  int i,ix,ic;
  for (i=58;i<63;i++)
    hLine(1,i,126,1);
  hLine(0,63,127,2);
  hLine(0,57,127,2);
  for (i=0;i<128;i+=21)
    vLine(i,58,62,2);
  vLine(127,57,63,2);
  i=0;
  ix=0;
  ic=0;
  while (menu[i]!=0)
  {
    OutChar(2+ix+ic*5,56,menu[i],0,font);
    i++;
    ic++;
    if (i%4==0)
    {
      ix+=21;
      ic=0;
    }
  }
}*/
