#if !defined __TESTKEY
#define __TESTKEY
#include <dos.h>

#define K_F1				10,6
#define K_F2				10,5	
#define K_F3				10,4	
#define K_F4				10,3	
#define K_F5				10,2	
#define K_F6				10,1

#define K_RIGHT 			9,3
#define K_LEFT  			9,6
#define K_UP				9,5
#define K_DOWN				9,4

#define K_SHIFT				8,6
#define K_CTRL              8,5
#define K_OPTN              8,4
#define K_MENU				8,3

#define K_ALPHA             7,6
#define K_VARS              7,5
#define K_POWER             7,4
#define K_ESC				7,3

#define K_A                 6,6
#define K_B                 6,5
#define K_C                 6,4
#define K_D                 6,3
#define K_E                 6,2
#define K_F                 6,1

#define K_G                 5,6
#define K_H                 5,5
#define K_I                 5,4
#define K_J                 5,3
#define K_K                 5,2
#define K_L                 5,1

#define K_M                 4,6
#define K_N                 4,5
#define K_O                 4,4
#define K_DEL               4,3

#define K_P                 3,6
#define K_Q                 3,5
#define K_R                 3,4
#define K_S                 3,3
#define K_T                 3,2

#define K_U                 2,6
#define K_V                 2,5
#define K_W                 2,4
#define K_X                 2,3
#define K_Y                 2,2

#define K_Z                 1,6
#define K_SPACE             1,5
#define K_EXP               1,4
#define K_ANS               1,3
#define K_EXE               1,2

#define K_AC				0,0

//================================
//VALUES FOR getkey:

#define G_F1				11
#define G_F2				12	
#define G_F3				13
#define G_F4				14	
#define G_F5				15
#define G_F6				0

#define G_RIGHT 			26
#define G_LEFT  			24
#define G_UP				25
#define G_DOWN				34

#define G_SHIFT				21
#define G_CTRL              22
//Caps Lock
#define G_OPTN              23
//Tab
#define G_MENU				0

//Alt
#define G_ALPHA             31
//Insert
#define G_VARS              32
//Home
#define G_POWER             33
#define G_ESC				0
#define G_DEL               61
#define G_SPACE             92
//End
#define G_EXP               93
//Page Down
#define G_ANS               94
#define G_EXE               95

#define G_AC				65

unsigned char testkey(unsigned char ligne,unsigned char colonne)
{			
asm	{
	mov ax,1
	mov cl,ligne
	shl ax,cl		
	out 0x13,ax
	mov cx,10 
} key_loop: asm {
    loop key_loop
	in al,0x13		
	mov ah,1
	mov cl,colonne
	shl ah,cl		
	and al,ah		
	}
	return _AL;
}

unsigned char tgetkey()
{
  if (testkey(K_A)) {while(testkey(K_A)); return 41; }
  if (testkey(K_B)) {while(testkey(K_B)); return 42; }
  if (testkey(K_C)) {while(testkey(K_C)); return 43; }
  if (testkey(K_D)) {while(testkey(K_D)); return 44; }
  if (testkey(K_E)) {while(testkey(K_E)); return 45; }
  if (testkey(K_F)) {while(testkey(K_F)); return 0; }
  if (testkey(K_G)) {while(testkey(K_G)); return 51; }
  if (testkey(K_H)) {while(testkey(K_H)); return 52; }
  if (testkey(K_I)) {while(testkey(K_I)); return 53; }
  if (testkey(K_J)) {while(testkey(K_J)); return 0; }
  if (testkey(K_K)) {while(testkey(K_K)); return 54; }
  if (testkey(K_L)) {while(testkey(K_L)); return 55; }
  if (testkey(K_M)) {while(testkey(K_M)); return 62; }
  if (testkey(K_N)) {while(testkey(K_N)); return 63; }
  if (testkey(K_O)) {while(testkey(K_O)); return 64; }
  if (testkey(K_Q)) {while(testkey(K_Q)); return 73; }
  if (testkey(K_P)) {while(testkey(K_P)); return 72; }
  if (testkey(K_R)) {while(testkey(K_R)); return 74; }
  if (testkey(K_S)) {while(testkey(K_S)); return 71; }
  if (testkey(K_T)) {while(testkey(K_T)); return 75; }
  if (testkey(K_U)) {while(testkey(K_U)); return 82; }
  if (testkey(K_V)) {while(testkey(K_V)); return 83; }
  if (testkey(K_W)) {while(testkey(K_W)); return 84; }
  if (testkey(K_X)) {while(testkey(K_X)); return 81; }
  if (testkey(K_Y)) {while(testkey(K_Y)); return 85; }
  if (testkey(K_Z)) {while(testkey(K_Z)); return 91; }
  
  if (testkey(K_UP)) {while(testkey(K_UP)); return G_UP; }
  if (testkey(K_DOWN)) {while(testkey(K_DOWN)); return G_DOWN; }
  if (testkey(K_LEFT)) {while(testkey(K_LEFT)); return G_LEFT; }
  if (testkey(K_RIGHT)) {while(testkey(K_RIGHT)); return G_RIGHT; }
  if (testkey(K_EXE)) {while(testkey(K_EXE)); return G_EXE; }
  if (testkey(K_SPACE)) {while(testkey(K_SPACE)); return G_SPACE; }
  if (testkey(K_EXP)) {while(testkey(K_EXP)); return G_EXP; }
  if (testkey(K_ANS)) {while(testkey(K_ANS)); return G_ANS; }
  if (testkey(K_DEL)) {while(testkey(K_DEL)); return G_DEL; }
  if (testkey(K_AC)) {while(testkey(K_AC)); return G_AC; }
  if (testkey(K_ALPHA)) {while(testkey(K_ALPHA)); return G_ALPHA; }
  if (testkey(K_VARS)) {while(testkey(K_VARS)); return G_VARS; }
  if (testkey(K_POWER)) {while(testkey(K_POWER)); return G_POWER; }
  if (testkey(K_ESC)) {while(testkey(K_ESC)); return G_ESC; }
  if (testkey(K_SHIFT)) {while(testkey(K_SHIFT)); return G_SHIFT; }
  if (testkey(K_CTRL)) {while(testkey(K_CTRL)); return G_CTRL; }
  if (testkey(K_OPTN)) {while(testkey(K_OPTN)); return G_OPTN; }
  if (testkey(K_MENU)) {while(testkey(K_MENU)); return G_MENU; }
  if (testkey(K_F1)) {while(testkey(K_F1)); return G_F1; }
  if (testkey(K_F2)) {while(testkey(K_F2)); return G_F2; }
  if (testkey(K_F3)) {while(testkey(K_F3)); return G_F3; }
  if (testkey(K_F4)) {while(testkey(K_F4)); return G_F4; }
  if (testkey(K_F5)) {while(testkey(K_F5)); return G_F5; }
  if (testkey(K_F6)) {while(testkey(K_F6)); return G_F6; }
  
  return 0;
  
}

unsigned char tgetkey_fast()
{
  if (testkey(K_A)) return 41; 
  if (testkey(K_B)) return 42; 
  if (testkey(K_C)) return 43; 
  if (testkey(K_D)) return 44; 
  if (testkey(K_E)) return 45; 
  if (testkey(K_F)) return 0; 
  if (testkey(K_G)) return 51; 
  if (testkey(K_H)) return 52; 
  if (testkey(K_I)) return 53; 
  if (testkey(K_J)) return 54; 
  if (testkey(K_K)) return 55; 
  if (testkey(K_L)) return 0; 
  if (testkey(K_M)) return 62; 
  if (testkey(K_N)) return 63; 
  if (testkey(K_O)) return 64; 
  if (testkey(K_Q)) return 73; 
  if (testkey(K_P)) return 72; 
  if (testkey(K_R)) return 74; 
  if (testkey(K_S)) return 71; 
  if (testkey(K_T)) return 75; 
  if (testkey(K_U)) return 82; 
  if (testkey(K_V)) return 83; 
  if (testkey(K_W)) return 84; 
  if (testkey(K_X)) return 81; 
  if (testkey(K_Y)) return 85; 
  if (testkey(K_Z)) return 91; 
  
  if (testkey(K_UP)) return G_UP; 
  if (testkey(K_DOWN)) return G_DOWN; 
  if (testkey(K_LEFT)) return G_LEFT; 
  if (testkey(K_RIGHT)) return G_RIGHT; 
  if (testkey(K_EXE)) return G_EXE; 
  if (testkey(K_SPACE)) return G_SPACE; 
  if (testkey(K_EXP)) return G_EXP; 
  if (testkey(K_ANS)) return G_ANS; 
  if (testkey(K_DEL)) return G_DEL; 
  if (testkey(K_AC)) return G_AC; 
  if (testkey(K_ALPHA)) return G_ALPHA; 
  if (testkey(K_VARS)) return G_VARS; 
  if (testkey(K_POWER))  return G_POWER; 
  if (testkey(K_ESC))  return G_ESC; 
  if (testkey(K_SHIFT))  return G_SHIFT; 
  if (testkey(K_CTRL)) return G_CTRL; 
  if (testkey(K_OPTN)) return G_OPTN; 
  if (testkey(K_MENU)) return G_MENU; 
  if (testkey(K_F1))  return G_F1; 
  if (testkey(K_F2)) return G_F2; 
  if (testkey(K_F3))  return G_F3; 
  if (testkey(K_F4))  return G_F4; 
  if (testkey(K_F5))  return G_F5; 
  if (testkey(K_F6))  return G_F6; 
  
  return 0;
  
}

unsigned char tgetchar()
{
  unsigned char ch=0;
  while (ch==0) ch=tgetkey_fast();
  return ch;
}

void twaitkey(char key)
{
  while (tgetkey()!=key);
}

//============================================================================
unsigned char get_APO()
{
  asm{
       mov ax,0x40
       mov es,ax
       mov al,es:0xE3
     }
  return _AL;
}

void set_APO(unsigned char time_off)
{
  asm{
       mov ax,0x40
       mov es,ax
       mov al,time_off
       mov es:0xE3,al
       mov ah,0x8
       int 0x21
	 }
}

void emptybuf()
{
  asm{
       mov ax,0x40
       mov es,ax
       mov al,es:0x1B
       mov es:0x1D,al
     }
}


void emptykey()
{
  loop:
  asm{
       mov ax,0x7FF
       out 0x13,ax
       in al,0x13
       cmp al,0x0
       jne loop
       mov ax,0x7FF
       out 0x13,ax
       in al,0x13
       cmp al,0x0
       jne loop
     }
}

int OldInt9Seg,OldInt9Off; // adresses de l'interruption 9

void desactint9()
{
  asm{
       xor ax,ax
       mov es,ax
       mov ax,es:0x26     // Segment interruption 9
       mov OldInt9Seg,ax  // stocke dans variable
       mov ax,es:0x24     // Offset int9
       mov OldInt9Off,ax  // stocke dans variable
       mov ax,es:0x03FE   // segment int FF
       mov es:0x26,ax     // remplace seg 9 par seg FF
       mov ax,es:0x03FC   // offset int FF
       mov es:0x24,ax     // remplace offset 9 par offset FF
     }
}


// Active l'interruption 9. Par Superna.
// Fonction extraite de DB-Lib.h
void actint9()
{
  asm{
       xor ax,ax
       mov es,ax
       mov ax,OldInt9Seg
       mov es:0x26,ax     // remet segment d'origine
       mov ax,OldInt9Off
       mov es:0x24,ax     // remet offset d'origine
     }
}
//========== do testow:
void interrupt (*int9)(void);
//void interrupt (*int53)(void);
void interrupt nope(void)
	{
	}

void close_v9(void)
{
  int9=_dos_getvect(0x9);
  _dos_setvect(0x9,nope);
}

void set_v9(void)
{
  setvect(9,int9);
}

#endif
